SystemOrganization addCategory: #'Glamour-Morphic-Brick-Tests'!

TestCase subclass: #GLMBrickLayouterTests
	instanceVariableNames: 'layouter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Tests'!

!GLMBrickLayouterTests methodsFor: 'asserting' stamp: 'AliakseiSyrel 2/4/2015 16:06'!
assertAllSubbricksAreClean: aBrick

	aBrick withAllSubbricks do: [ :each | self assertBrickClean: each ]! !

!GLMBrickLayouterTests methodsFor: 'asserting' stamp: 'AliakseiSyrel 2/4/2015 16:05'!
assertAllSubbricksAreDirty: aBrick

	aBrick withAllSubbricks do: [ :each | self assertBrickDirty: each ]! !

!GLMBrickLayouterTests methodsFor: 'asserting' stamp: 'AliakseiSyrel 2/4/2015 16:05'!
assertBrickClean: aBrick

	self assertWidthClean: aBrick.
	self assertHeightClean: aBrick! !

!GLMBrickLayouterTests methodsFor: 'asserting' stamp: 'AliakseiSyrel 2/4/2015 16:04'!
assertBrickDirty: aBrick

	self assertWidthDirty: aBrick.
	self assertHeightDirty: aBrick! !

!GLMBrickLayouterTests methodsFor: 'asserting' stamp: 'AliakseiSyrel 2/4/2015 16:05'!
assertHeightClean: aBrick

	self assert: aBrick wrappedBounds heightState equals: #clean.
	self assert: aBrick wrappedBounds isHeightDirty not.
	self assert: aBrick wrappedBounds isHeightClean! !

!GLMBrickLayouterTests methodsFor: 'asserting' stamp: 'AliakseiSyrel 2/4/2015 16:03'!
assertHeightDirty: aBrick

	self assert: aBrick wrappedBounds heightState equals: #dirty.
	self assert: aBrick wrappedBounds isHeightDirty.
	self assert: aBrick wrappedBounds isHeightClean not! !

!GLMBrickLayouterTests methodsFor: 'asserting' stamp: 'AliakseiSyrel 2/4/2015 16:04'!
assertWidthClean: aBrick

	self assert: aBrick wrappedBounds widthState equals: #clean.
	self assert: aBrick wrappedBounds isWidthDirty not.
	self assert: aBrick wrappedBounds isWidthClean! !

!GLMBrickLayouterTests methodsFor: 'asserting' stamp: 'AliakseiSyrel 2/4/2015 16:04'!
assertWidthDirty: aBrick

	self assert: aBrick wrappedBounds widthState equals: #dirty.
	self assert: aBrick wrappedBounds isWidthDirty.
	self assert: aBrick wrappedBounds isWidthClean not! !

!GLMBrickLayouterTests methodsFor: 'instance-creation' stamp: 'AliakseiSyrel 2/4/2015 16:34'!
newBrickFullHeightAndWidthDependsOnParent: anInteger

	^ GLMBrick new
		vSpaceFill;
		hSpaceFill: anInteger;
		yourself! !

!GLMBrickLayouterTests methodsFor: 'instance-creation' stamp: 'AliakseiSyrel 2/4/2015 16:26'!
newBrickWithFullDependsOnChildren

	^ GLMBrick new 
		hShrinkWrap;
		vShrinkWrap;
		yourself! !

!GLMBrickLayouterTests methodsFor: 'instance-creation' stamp: 'AliakseiSyrel 2/4/2015 16:10'!
newBrickWithFullFill

	^ GLMBrick new 
		hSpaceFill;
		vSpaceFill;
		yourself! !

!GLMBrickLayouterTests methodsFor: 'instance-creation' stamp: 'AliakseiSyrel 2/4/2015 16:08'!
newBrickWithStaticExtent

	^ GLMBrick new 
		height: self staticHeight;
		width: self staticWidth;
		yourself! !

!GLMBrickLayouterTests methodsFor: 'running' stamp: 'AliakseiSyrel 2/4/2015 15:56'!
setUp
	super setUp.
	
	layouter := GLMBrickLayouter new! !

!GLMBrickLayouterTests methodsFor: 'defaults' stamp: 'AliakseiSyrel 2/4/2015 16:36'!
staticExtent

	^ self staticWidth  @ self staticHeight! !

!GLMBrickLayouterTests methodsFor: 'defaults' stamp: 'AliakseiSyrel 2/4/2015 16:08'!
staticHeight

	^ 100! !

!GLMBrickLayouterTests methodsFor: 'defaults' stamp: 'AliakseiSyrel 2/4/2015 16:08'!
staticWidth

	^ 100! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:42'!
test100DependsOnChildrenBricksInsideOneStatic
	|root current|
	
	root := self newBrickWithFullDependsOnChildren.
	current := root.
	1 to: 99 do: [ :index |
		current := current addBrickBack: self newBrickWithFullDependsOnChildren ].
	current := current addBrickBack: self newBrickWithStaticExtent.
	
	self assertAllSubbricksAreClean: root.
	
	self assert: root extent equals: current extent
	! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:42'!
test100FillBricksInsideEachOtherIndideStatic
	|root current|
	
	root := self newBrickWithStaticExtent.
	current := root.
	1 to: 100 do: [ :index |
		current := current addBrickBack: self newBrickWithFullFill ].
	
	self assertAllSubbricksAreClean: root.
	
	self assert: current extent equals: root extent
	! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:42'!
test100StaticBricksInsideEachOtherIndideStatic
	|root current|
	
	root := self newBrickWithStaticExtent.
	current := root.
	1 to: 100 do: [ :index |
		current := current addBrickBack: self newBrickWithStaticExtent ].
	
	self assertAllSubbricksAreClean: root.
	
	self assert: current extent equals: root extent
	! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:43'!
testBrickDependsOnChildrenOneStatic
	|root brick|
	
	root := self newBrickWithFullDependsOnChildren.
	brick := self newBrickWithStaticExtent.
	
	root addBrickBack: brick.
	
	self assert: root isWidthDependsOnChildren.
	self assert: root isHeightDependsOnChildren.
	
	self assertAllSubbricksAreClean: root.
	
	self assert: root extent equals: brick extent! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:43'!
testChangeChildrenInParent
	|parent brick|
	parent := self newBrickWithFullDependsOnChildren.
	brick := self newBrickWithStaticExtent.
	
	parent addBrickBack: brick.
	self assertAllSubbricksAreClean: parent.
	self assert: parent extent equals: brick extent.
	"height and width are changed, so parent should be re-layouted"
	brick height: self staticHeight * 2.
	brick width: self staticWidth * 2.
	
	self assertAllSubbricksAreClean: parent.
	self assert: brick extent equals: self staticExtent * 2.
	self assert: parent extent equals: brick extent
	
! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:40'!
testChangeChildrenInParentAndSubchildren
	|parent brick child|
	parent := self newBrickWithFullDependsOnChildren.
	brick := self newBrickWithStaticExtent.
	child := self newBrickFullHeightAndWidthDependsOnParent: 100.
	
	parent addBrickBack: brick.
	brick addBrickBack: child.
	self assertAllSubbricksAreClean: parent.
	self assert: parent extent equals: brick extent.
	self assert: child extent equals: brick extent.
	"height and width are changed, so parent should be re-layouted"
	brick height: self staticHeight * 2.
	brick width: self staticWidth * 2.
	
	self assertAllSubbricksAreClean: parent.
	self assert: brick extent equals: self staticExtent * 2.
	self assert: parent extent equals: brick extent.
	self assert: child extent equals: brick extent
	
! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/4/2015 16:28'!
testEmptyBrickDependsOnChildren
	|brick|
	
	brick := self newBrickWithFullDependsOnChildren.
	
	self assert: brick isWidthDependsOnChildren.
	self assert: brick isHeightDependsOnChildren.
	
	self assertAllSubbricksAreDirty: brick.
	brick doLayout.
	self assertAllSubbricksAreClean: brick.
	
	self assert: brick extent equals: 0@0! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:43'!
testFillBrickInsideStatic
	|root brick|
	
	root := self newBrickWithStaticExtent.
	brick := self newBrickWithFullFill.
	brick isWidthDependsOnParent.
	brick isHeightDependsOnParent.
	root addBrickBack: brick.
	
	self assertAllSubbricksAreClean: root.
	self assert: brick extent equals: root extent
	! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:44'!
testFreshBrickIsDirty

	self assertBrickDirty: GLMBrick new! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:55'!
testOneDependsOnParentOneDependsOnChildrenInsideStatic
	|root brick1 brick2 brick3 staticWidth staticHeight|
	
	staticWidth := 20.
	staticHeight := 50.
	
	root := self newBrickWithStaticExtent.
	brick1 := self newBrickFullHeightAndWidthDependsOnParent: 100.
	brick2 := self newBrickWithFullDependsOnChildren.
	brick3 := GLMBrick new width: staticWidth; height: staticHeight; yourself.
	
	root addBrickBack: brick1.
	self assert: root extent equals: self staticExtent.
	self assert: brick1 brickBounds equals: (0@0 extent: self staticExtent).
	
	root addBrickBack: brick2.
	self assert: root extent equals: self staticExtent.
	self assert: brick1 brickBounds equals: (0@0 extent: self staticExtent).
	self assert: brick2 brickBounds equals: (self staticWidth @0 extent: 0@0).
	
	brick2 addBrickBack: brick3.
		
	self assertAllSubbricksAreClean: root.
	
	self assert: root extent equals: self staticExtent.
	self assert: brick1 brickBounds equals: (0@0 extent: (self staticWidth - staticWidth) @ self staticHeight).
	self assert: brick2 brickBounds equals: ((self staticWidth - staticWidth)@0 extent: (staticWidth) @ staticHeight).
	self assert: brick3 brickBounds equals: (0@0 extent: (staticWidth) @ staticHeight).
	! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:44'!
testOneDependsOnParentOneStaticInsideStatic
	|root brick1 brick2 staticWidth|
	
	staticWidth := 20.
	
	root := self newBrickWithStaticExtent.
	brick1 := self newBrickFullHeightAndWidthDependsOnParent: 100.
	brick2 := GLMBrick new width: staticWidth; vSpaceFill; yourself.
	
	root
		addBrickBack: brick1;
		addBrickBack: brick2.
	
	self assertAllSubbricksAreClean: root.
	
	self assert: root extent equals: self staticExtent.
	self assert: brick1 brickBounds equals: (0@0 extent: (self staticWidth - staticWidth) @ self staticHeight).
	self assert: brick2 brickBounds equals: ((self staticWidth - staticWidth)@0 extent: (staticWidth) @ self staticHeight).
	! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:44'!
testOneStaticBrick
	|brick|
	
	brick := self newBrickWithStaticExtent.
	
	self assert: brick isWidthDependsOnMyself.
	self assert: brick isHeightDependsOnMyself.
	self assertBrickClean: brick.
	self assert: brick extent equals: self staticExtent
	! !

!GLMBrickLayouterTests methodsFor: 'tests' stamp: 'AliakseiSyrel 2/8/2015 13:44'!
testTwoDependsOnParentInsideStatic
	|root brick1 brick2|
	
	root := self newBrickWithStaticExtent.
	brick1 := self newBrickFullHeightAndWidthDependsOnParent: 50.
	brick2 := self newBrickFullHeightAndWidthDependsOnParent: 50.
	
	root
		addBrickBack: brick1;
		addBrickBack: brick2.

	self assertAllSubbricksAreClean: root.
	
	self assert: root extent equals: self staticExtent.
	self assert: brick1 brickBounds equals: (0@0 extent: (self staticWidth / 2) @ self staticHeight).
	self assert: brick2 brickBounds equals: ((self staticWidth / 2)@0 extent: (self staticWidth / 2) @ self staticHeight).
	! !
